# -*- coding: utf-8 -*-
#
# This file is part of Radicale Server - Calendar Server
# Copyright © 2012 chrysn <chrysn@fsfe.org>
#
# This library is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Radicale.  If not, see <http://www.gnu.org/licenses/>.

"""
GIT versioning storage backend.

"""

import os
from .filesystem import Collection as BaseCollection
import subprocess

class Collection(BaseCollection):
    def __init__(self, *args, **kwargs):
        super(Collection, self).__init__(*args, **kwargs)
        self.__dir, self.__file = os.path.split(self._path)

    def save(self, text):
        super(Collection, self).save(text)
        subprocess.check_call(["git", "add", self.__file], cwd=self.__dir)
        subprocess.check_call(["git", "commit", "-m", "saved object"], cwd=self.__dir)

    def delete(self):
        raise NotImplementedError
        #super(Collection, self).delete()
